// interfaceDoc.cpp : implementation of the CInterfaceDoc class
//program by vikas

#include "stdafx.h"
#include "interface.h"
#include <math.h>
#include "interfaceDoc.h"
#include "Linkage.h"
#include "SldDlg.h"
#include "EntryDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#include "interface.cpp"

#define ZERO  0.5

#define PI 3.141592653589793
/////////////////////////////////////////////////////////////////////////////
double distance(CPoint pt1,CPoint pt2)
{
	long double d = ((long double)(pt2.x-pt1.x)*(long double)(pt2.x-pt1.x)+(long double)(pt2.y-pt1.y)*(long double)(pt2.y-pt1.y));
	double dd = sqrt(d);
	if(d < 0)
		return sqrt(-d);
//	else
	return dd;
}
int compare( const void *arg1, const void *arg2 )
{	
	return (int)(*(double*)arg1 - *(double*)arg2);
}

/////////////////////////////////////////////////////////////////////////////
// CInterfaceDoc

IMPLEMENT_DYNCREATE(CInterfaceDoc, CDocument)

BEGIN_MESSAGE_MAP(CInterfaceDoc, CDocument)
	//{{AFX_MSG_MAP(CInterfaceDoc)
		ON_COMMAND(ID_TOOLS_LINK,OnToolsLink)
		ON_COMMAND(ID_TOOLS_SLIDER,OnToolsSlider)
		ON_COMMAND(ID_TOOLS_REVOLUTE,OnToolsRevolute)
		ON_COMMAND(ID_TOOLS_REFERANCE,OnToolsReferance)
		ON_COMMAND(ID_TOOLS_DELETE,OnToolsDelete)
	ON_COMMAND(ID_TOOLS_COUPLER, OnToolsCoupler)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_COUPLER, OnUpdateToolsCoupler)
	ON_COMMAND(ID_TOOLS_RUN, OnToolsRun)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_RUN, OnUpdateToolsRun)
	ON_COMMAND(ID_TOOLS_COMPILE, OnToolsCompile)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_COMPILE, OnUpdateToolsCompile)
	ON_COMMAND(ID_TOOLS_PLOTS, OnToolsPlots)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_PLOTS, OnUpdateToolsPlots)
	ON_COMMAND(ID_TOOLS_INPUT, OnToolsInput)
	ON_UPDATE_COMMAND_UI(ID_TOOLS_INPUT, OnUpdateToolsInput)
	//}}AFX_MSG_MAP
	//vikas added
		ON_UPDATE_COMMAND_UI(ID_TOOLS_LINK,OnUpdateToolsLink)
		ON_UPDATE_COMMAND_UI(ID_TOOLS_SLIDER,OnUpdateToolsSlider)
		ON_UPDATE_COMMAND_UI(ID_TOOLS_REVOLUTE,OnUpdateToolsRevolute)
		ON_UPDATE_COMMAND_UI(ID_TOOLS_REFERANCE,OnUpdateToolsReferance)
		ON_UPDATE_COMMAND_UI(ID_TOOLS_DELETE,OnUpdateToolsDelete)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInterfaceDoc construction/destruction

CInterfaceDoc::CInterfaceDoc()
{
	// TODO: add one-time construction code here
	m_fSet = FALSE;
	m_hCross  = AfxGetApp()->LoadCursor(IDC_CROSS1);
	m_hSelect = AfxGetApp()->LoadCursor(IDC_SELECT);
	m_TotalLink = 15;
	m_flag = 0;
 	if(!(m_ptRev = new CPoint[m_TotalLink/2]))
		exit(0);
	if(!(m_ptSldr= new CPoint[m_TotalLink/2]))
		exit(0);
	if(!(m_ptRef = new CPoint[m_TotalLink]))
//		cerr<<"Cann't craete m_Point Array at CInterfaceDoc::CInterfaceDoc()"<<endl;
		exit(0);

	m_sCoord = "0,0";
	m_w = 15;
	m_a = 5;
	m_ra = NULL;
	m_rm = NULL;
	m_dra = NULL;
	m_drm = NULL;
	m_ddra = NULL;
	m_ddrm = NULL;
	m_linkCatchOn = FALSE;
//	m_IsCompiled = FALSE;
	m_nNewDoc = 0;

	m_sldrDlgShow = false;

}

CInterfaceDoc::~CInterfaceDoc()
{
	delete m_ra;
	delete m_rm;
	delete m_dra;
	delete m_drm;
	delete m_ddra;
	delete m_ddrm;

}

BOOL CInterfaceDoc::OnNewDocument() 
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	//timer
	m_timerValue = 50;
	//is compiled
	m_IsCompiled = FALSE;
	//FLAG FOR TOOL BAR
	m_flag = 0;
	//WHETHER INPUT LINK HAS BEEN SET.
	m_IsInput = FALSE;		

	m_IndexRef   = 0;
	m_IndexRev   = 0;
	m_IndexSldr  = 0;
	m_EndIndex   = 0;
	m_InputLinkIndex = 0;
	m_IndexCoupler = 0;
	
	m_sldrAttachIndex = 0;
//	m_sldrPathIndex = 0;
	m_IndexRef = 0;
	m_linkList.RemoveAll();
//	m_loopList.RemoveAll();
	m_nNewDoc++;
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CInterfaceDoc serialization

void CInterfaceDoc::Serialize(CArchive& ar)
{
	POSITION pos;
	CLink *pLink;
	int i;
	int flag = 0;
	if (ar.IsStoring())
	{
		// TODO: add storing code here	
		ar<<m_EndIndex;
		for(i = 0; i < m_EndIndex/2; i++)
		{
			pLink = GetLink(GetLink(i));
			pLink->Serialize(ar);
		}
		ar<<m_IndexRef<<m_IndexRev<<m_IndexSldr;
		for(i = 0; i < m_IndexRef; i++)
			ar<<m_ptRef[i];
		for(i = 0; i < m_IndexRev; i++)
			ar<<m_ptRev[i];
		for(i = 0; i < m_IndexSldr; i++)
			ar<<m_ptSldr[i];
		ar<<m_InputLinkIndex;
		ar<<m_w<<m_a;
		ar<<m_timerValue;
		//for coupler
/*		ar<<m_ac<<m_rc;
		m_cplrLink.Serialize(ar);
		ar<<m_cplrLinkIndex;
		ar<<m_cplrPt;
*/		//for slider
		m_sldrAttachLink.Serialize(ar);
		m_sldrPathLink.Serialize(ar);
		ar<<m_sldrAttachIndex;
		ar<<m_sldrPt;

	}
	else
	{
		// TODO: add loading code here
		
		ar>>m_EndIndex;
		for(i = 0; i < m_EndIndex/2; i++)
			if(pLink = new CLink)
			{
				pLink->Serialize(ar);
				m_linkList.AddTail(pLink);
			}
		
		ar>>m_IndexRef>>m_IndexRev>>m_IndexSldr;

		for(i = 0; i < m_IndexRef; i++)
			ar>>m_ptRef[i];
		for(i = 0; i < m_IndexRev; i++)
			ar>>m_ptRev[i];
		for(i = 0; i < m_IndexSldr; i++)
			ar>>m_ptSldr[i];
		ar>>m_InputLinkIndex;
		ar>>m_w>>m_a;
		ar>>m_timerValue;
/*		//for coupler		
		ar>>m_ac>>m_rc;
		m_cplrLink.Serialize(ar);
		ar>>m_cplrLinkIndex;
		ar>>m_cplrPt;
*/		//for slider
		m_sldrAttachLink.Serialize(ar);
		m_sldrPathLink.Serialize(ar);
		ar>>m_sldrAttachIndex;
		ar>>m_sldrPt;
		m_IsCompiled = false;
		m_flag = 0;
		UpdateAllViews(NULL);
	}

}

/////////////////////////////////////////////////////////////////////////////
// CInterfaceDoc diagnostics

#ifdef _DEBUG
void CInterfaceDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CInterfaceDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CInterfaceDoc commands

void CInterfaceDoc::OnToolsLink()
{
	
	m_flag = (m_flag == ID_TOOLS_LINK ? 0 : ID_TOOLS_LINK);
//	::LoadStandardCursor (IDC_WAIT);   
//	SetSystemCursor(m_hCross,32512);
		
}

void CInterfaceDoc::OnToolsSlider()
{
	m_flag = (m_flag == ID_TOOLS_SLIDER ? 0 : ID_TOOLS_SLIDER);
	if(m_flag == ID_TOOLS_SLIDER)
		m_linkCatchOn = TRUE;
	else
		m_linkCatchOn = FALSE;
	CSldDlg	 dlg;
	if(!m_sldrDlgShow)
		if(dlg.DoModal() == IDOK)
		{
			UpdateAllViews(NULL);
//			m_flagD = FALSE;
		}
}
void CInterfaceDoc::OnToolsRevolute()
{
	m_flag = (m_flag == ID_TOOLS_REVOLUTE ? 0 : ID_TOOLS_REVOLUTE);

}
void CInterfaceDoc::OnToolsReferance()
{
	m_flag = (m_flag ==  ID_TOOLS_REFERANCE ? 0 : ID_TOOLS_REFERANCE);

}

void CInterfaceDoc::OnToolsDelete()
{
		m_flag = (m_flag == ID_TOOLS_DELETE ? 0 : ID_TOOLS_DELETE);
}

void CInterfaceDoc::OnToolsCoupler() 
{
	// TODO: Add your command handler code here
/*	CColorDialog colorDlg;
	if(colorDlg.DoModal() == IDOK)
	{
		m_cplrColor == colorDlg.GetColor();
*/		m_flag = ID_TOOLS_COUPLER;
//	}

}

void CInterfaceDoc::OnUpdateToolsCoupler(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(m_EndIndex >= 6)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
	pCmdUI->SetCheck(m_flag == ID_TOOLS_COUPLER ? 1 : 0);
	if(m_flag == ID_TOOLS_COUPLER)
		m_linkCatchOn = TRUE;
	else
		m_linkCatchOn = FALSE;
		
}

void CInterfaceDoc::OnUpdateToolsLink(CCmdUI *pCmdUI)
{
	if(m_flag == ID_TOOLS_LINK)
		pCmdUI->SetCheck();//(1)
	else
		pCmdUI->SetCheck(0);
}
void CInterfaceDoc::OnUpdateToolsSlider(CCmdUI *pCmdUI)
{
	if(m_flag == ID_TOOLS_SLIDER)
		pCmdUI->SetCheck();
	else
		pCmdUI->SetCheck(0);

}
void CInterfaceDoc::OnUpdateToolsRevolute(CCmdUI *pCmdUI)
{
	if(m_flag == ID_TOOLS_REVOLUTE)
		pCmdUI->SetCheck();
	else
		pCmdUI->SetCheck(0);
}
void CInterfaceDoc::OnUpdateToolsReferance(CCmdUI *pCmdUI)
{
	if(m_flag == ID_TOOLS_REFERANCE)
		pCmdUI->SetCheck();
	else
		pCmdUI->SetCheck(0);
}

void CInterfaceDoc::OnUpdateToolsDelete(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck((m_flag == ID_TOOLS_DELETE ? 1:0));
}

void CInterfaceDoc::AddLink()
{
	if(CLink *pLink = new CLink)
	{
		pLink->m_pt1 = m_End1;//m_Point[m_EndIndex - 1];
		pLink->m_pt2 = m_End2;//m_Point[m_EndIndex];
		m_linkList.AddTail(pLink);
	}
	else
		exit(1);
}

POSITION CInterfaceDoc::GetLink(int i)
{
	POSITION  pos = m_linkList.GetHeadPosition();
	CLink *pLink;
	//proceed only when the count is GT one
	if( i < m_linkList.GetCount())
	{
		//get the next position if it is other than first one
		for(int j = 0; j < i; j++)
			if(m_linkList.GetNext(pos));//intentionally
				pLink = (CLink *)m_linkList.GetAt(pos);
		m_LinkCurr.m_pt1 = pLink->m_pt1;
		m_LinkCurr.m_pt2 = pLink->m_pt2;
	}
	return pos;

}

void CInterfaceDoc::SetLinkTail()
{
	
	POSITION pos;
	CObject *pa;
	if( ( pos = m_linkList.GetTailPosition()) != NULL )
    {
		// Save the old pointer for deletion.
		pa = (CObject *)m_linkList.GetAt(pos);
		// Replace the tail element.
		m_linkList.SetAt(pos,new CLink(m_End1,m_End2));//m_Point[m_EndIndex - 1],m_Point[m_EndIndex - 0]));  
	    delete pa;  // Deletion avoids memory leak.
    }

}

POSITION CInterfaceDoc::NearestLink(CPoint& point,CDC& dc)
{
	int i,j,k;
	double d;
//  char str[20];
	CPoint pt_n;
	POSITION pos;
	for(i = 0; i < m_EndIndex/2; i++)
	{
		pos = GetLink(i);
//		wsprintf(str,"%d",i);
		
//		AfxMessageBox(str);
		for(j = -6; j <= 6;j++)
		{
			for(k = -6; k <= 6; k++)
			{
				pt_n.x = point.x + k;
				pt_n.y = point.y + j;
				if(dc.GetPixel(pt_n) == RGB(0,0,255))  
				{	
					d = pt_n.y - (m_LinkCurr.m_pt1.y + ((double)(m_LinkCurr.m_pt2.y - m_LinkCurr.m_pt1.y)/(double)(m_LinkCurr.m_pt2.x - m_LinkCurr.m_pt1.x)) *(pt_n.x - m_LinkCurr.m_pt1.x));
					if( fabs(d) <= ZERO )
					{
						point = pt_n;
						return pos;
						
					}

				}
			}
		}
	}
	return NULL;
}



void CInterfaceDoc::SetDirection()
{
	POSITION pos,*p;
	int n;
	CPoint ptL(9999,0);//point in the Left most 
	int l = 0,j =0,k= 0;
	//finding the left most point
	while(l < m_EndIndex/2)
	{
		pos = GetLink(l++);
		if(m_LinkCurr.m_pt1.x <= ptL.x)
		{	
			ptL = m_LinkCurr.m_pt1;
			j   = l-1;
		}
		if(m_LinkCurr.m_pt2.x <= ptL.x)
		{
			ptL = m_LinkCurr.m_pt2;
			j   = l-1;
		}
	}
/*	char str[25];
	wsprintf(str,"%d,%d",ptL.x,ptL.y);
	AfxMessageBox(str);
*/	//checking for 
	CLink tempLink = m_LinkCurr,*pLink;
	CPoint pt[2];
	p = GetLink(ptL,n);
	for(l = 0; l < n; l++)
	{
		pLink = (CLink *)m_linkList.GetAt(p[l]);
		if(pLink->m_pt1 == ptL)
			pt[l] = pLink->m_pt2;
		else 
			pt[l] = pLink->m_pt1;
	}

	
	POSITION posT;
	CLink *pLnkFirst;
	//which link is upper
    if(pt[0].y < pt[1].y)//in our device coordinate system is top left corner is 0,0
	{	
		posT  = GetLink(ptL,pt[0]);
		pLnkFirst = pLink = GetLink(posT);
		pLink->m_pt1 = ptL;
		pLink->m_pt2 = pt[0];
		while(pLink = ArrangeNext(pLink))
		{
			if(*pLink == *pLnkFirst) break;
//			wsprintf(str,"Tail %d,%d - Head %d,%d",pLink->m_pt1.x,pLink->m_pt1.y,pLink->m_pt2.x,pLink->m_pt2.y);
//			AfxMessageBox(str);
		}

	}
	else
	{	
		posT  = GetLink(ptL,pt[1]);
		pLnkFirst = pLink = GetLink(posT);//tail ----------------------> head
		pLink->m_pt1 = ptL;//make the left most pt as first pt of link as a tail of link vector
		pLink->m_pt2 = pt[1];//setting the head of link vector
		while(pLink = ArrangeNext(pLink))
		{
			if(*pLink == *pLnkFirst) break;
//			wsprintf(str,"Tail %d,%d - Head %d,%d",pLink->m_pt1.x,pLink->m_pt1.y,pLink->m_pt2.x,pLink->m_pt2.y);
//			AfxMessageBox(str);
		}
	}
	
}

void CInterfaceDoc::OnToolsRun() 
{
	// TODO: Add your command handler code here
	//ID_TOOLS_RUN
	
	m_flag = (m_flag == ID_TOOLS_RUN? 0 : ID_TOOLS_RUN);
	if(m_flag == ID_TOOLS_RUN)
	{
		SetTimer(m_hWnd,ID_TIMER,m_timerValue,NULL);
		UpdateAllViews(NULL);
	}
	else
	{
		KillTimer(m_hWnd,ID_TIMER);
		UpdateAllViews(NULL);
	}

	if(m_IsCompiled)
		LinkageCalc();
//	UpdateAllViews(NULL);
	
}

void CInterfaceDoc::OnUpdateToolsRun(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	//ID_TOOLS_RUN
	if(!m_IsCompiled)
			pCmdUI->Enable(FALSE);
		else
			pCmdUI->Enable(TRUE);

	if(m_flag == ID_TOOLS_RUN)
		pCmdUI->SetCheck();
	else
		pCmdUI->SetCheck(0);	
		
}



CLink *CInterfaceDoc::GetLink(POSITION pos)
{
	CLink *pLink;
	pLink = (CLink *)m_linkList.GetAt(pos);
	m_Link.m_pt1 = pLink->m_pt1;
	m_Link.m_pt2 = pLink->m_pt2;
	return pLink;
}

// find the link which contains the given pts.
POSITION CInterfaceDoc::GetLink(CPoint pt1, CPoint pt2)
{
	POSITION pos ;
	CLink *pLink ;
	pos = m_linkList.GetHeadPosition();
	pLink = (CLink *)m_linkList.GetAt(pos);
	if(pLink->m_pt1 == pt1 && pLink->m_pt2 == pt2)
		return pos;
	if(pLink->m_pt2 == pt1 && pLink->m_pt1 == pt2)
		return pos;
	for(int i = 1; i < m_linkList.GetCount(); i++)
	{
		if(m_linkList.GetNext(pos))
		{
			pLink = (CLink *)m_linkList.GetAt(pos);
			if(pLink->m_pt1 == pt1 && pLink->m_pt2 == pt2)
				return pos;
			if(pLink->m_pt2 == pt1 && pLink->m_pt1 == pt2)
				return pos;
		}
	}
	return NULL;
}
//get the links containing the point 'pt'
POSITION *CInterfaceDoc::GetLink(CPoint pt, int &j)
{
	POSITION *pos,ps;
	pos = new POSITION[5];
	j= 0;
	CLink *pLink ;
	if(ps = m_linkList.GetHeadPosition())//come at the start
		pLink = (CLink *)m_linkList.GetAt(ps);//the first link
	if(pLink->m_pt1 == pt || pLink->m_pt2 == pt)//check whether it have the pt as either of it end
	{
		pos[j] = ps;//store in the array
		j++;//incraease the counter
	}
	//searching other links which may contain the pt as their either end.
	for(int i = 1; i < m_linkList.GetCount(); i++)
	{
		if(m_linkList.GetNext(ps))
		{
			pLink = (CLink *)m_linkList.GetAt(ps);
			if(pLink->m_pt1 == pt || pLink->m_pt2 == pt)
			{	
				pos[j] = ps;
				if(j < 5) j++;
			}
		}

	}
	if(j == 0) return NULL;
	//else
	return pos;
}

CLink *CInterfaceDoc::GetNextLink(CLink *pLink)
{
	int n;
	POSITION *pos;
	CLink *plnk;
	if(pos = GetLink(pLink->m_pt2,n))
	{
		if(n > 2) 
		{
	//		cerr<<"More than one link to be choosen";
			exit(0);
		}
		plnk = GetLink(pos[0]);
		if(pLink->m_pt1 == plnk->m_pt1 && pLink->m_pt2 == plnk->m_pt2)
			return GetLink(pos[1]);
		else
			return plnk;
	}
	//else
	return NULL;
}

CLink *CInterfaceDoc::ArrangeNext(CLink *pLink)
{
	CLink *plnk;
	if((plnk = GetNextLink(pLink)))
	{
		if(plnk->m_pt1 == pLink->m_pt2);//do nothing as the link is in order;
		else //swap the points
		{
			plnk->m_pt2 = plnk->m_pt1;
			plnk->m_pt1 = pLink->m_pt2;
		}
		return plnk;
	}
	//else
		return NULL;

}

void CInterfaceDoc::LinkageCalc()
{

	CString str;
	CLink *pLink;
	POSITION pos;
	int j = 0,i;
	int k = 0;
	CPoint refPt;
//	POSITION pos;
//	CLink *pLink;
	//setting variables 


	Linkage(m_rm, m_ra, m_w, m_a,m_InputLinkIndex,m_indexR[0], m_indexR[1] , m_indexA[0], m_indexA[1], m_drm, m_dra, m_ddrm, m_ddra,m_EndIndex/2); 
/*	for(i = 0; i < m_EndIndex/2; i++)
	{
		str.Format("Link Length : %9.2lf, Angle : %9.2lf",m_rm[i],m_ra[i]);
//		AfxMessageBox(str);
	}
*/	//CHANGING ANGLE AND LENGTH IN COORDINATES
	CPoint pt;
	CLink *plink;
	j = m_indexRefLink;
//	if(j >= m_EndIndex/2 - 1)
//		j = 1;
//	else
//		j++ 
	refPt = m_RefLink.m_pt2;
	pos = m_loopList.GetHeadPosition();
//	m_loopList.GetNext(pos);
	for(i = 1; i < m_EndIndex/2 ; i++)
	{
		
//		if(j == m_EndIndex/2 - 1)
//			j = 0;
//		else 
//			j++;
//		for(ix = 0; ix < j; ix++)
		pLink = (CLink*) m_loopList.GetNext(pos);//get the next postiion
		pt.x = refPt.x + m_rm[i]*cos(m_ra[i]*PI/180);
		pt.y = refPt.y - m_rm[i]*sin(m_ra[i]*PI/180);
		if(plink = new CLink)
		{
			plink->m_pt2 = pt;
			plink->m_pt1 = refPt;
			if(i != m_EndIndex/2 - 1)
				refPt = pt;
			m_loopList.SetAt(pos,plink); 
//			j++;
		}

	}
	
	//setting the last point as a pt  at reference link
	if(!(m_sldrAttachIndex == i - 1))//(!(*plink == m_sldrAttachLink))//plink is changing so change it to index
	{
		plink = new CLink;
		plink->m_pt2 = m_RefLink.m_pt1;
		plink->m_pt1 = refPt;
		m_loopList.SetAt(pos,plink);
	}
	
/*	pos = m_loopList.GetHeadPosition();
	for(i = 0; i < m_EndIndex/2 ; i++)
	{
		plink = (CLink*) m_loopList.GetNext(pos);
		str.Format("Final %d,%d -------------> %d,%d",plink->m_pt1.x,plink->m_pt1.y,plink->m_pt2.x,plink->m_pt2.y);	
//		AfxMessageBox(str);
	}
	
*/
}

void CInterfaceDoc::DrawLinkage(CDC &dc)
{
	POSITION pos;
	CLink *pLink ;
	pos = m_loopList.GetHeadPosition();
//	pLink = (CLink *)m_loopList.GetAt(pos);

	for(int i = 0; i < m_EndIndex/2; i++)
	{
		pLink = (CLink*) m_loopList.GetNext(pos);
		dc.MoveTo(pLink->m_pt1.x,pLink->m_pt1.y);
		dc.LineTo(pLink->m_pt2.x,pLink->m_pt2.y);
		
	}

}

void CInterfaceDoc::DrawCoupler(CDC &dc)
{
	POSITION pos;
	CLink *pLink;//  = m_cplrLink;
	int i =0;
//	pos = m_loopList.GetHeadPosition();

/*	for(int i = 0; i < m_cplrLinkIndex; i++)
		pLink = (CLink*) m_loopList.GetNext(pos);
*/
/*	for(int i = 0; i < 360;i++)
	{
		m_ra[m_InputLinkIndex] = i;
*/		
		pos = m_loopList.GetHeadPosition();
		for(i = 0; i <= m_cplrLinkIndex; i++)
			pLink = (CLink*)m_loopList.GetNext(pos);
		dc.MoveTo(pLink->m_pt1.x + m_rc*cos((m_ra[m_cplrLinkIndex] + m_ac)*PI/180.0),pLink->m_pt1.y - m_rc*sin((m_ra[m_cplrLinkIndex] + m_ac)*PI/180.0));
//		Linkage(m_rm, m_ra , m_w, m_a,m_InputLinkIndex,m_indexR[0], m_indexR[1] , m_indexA[0], m_indexA[1], m_drm, m_dra, m_ddrm, m_ddra,m_EndIndex/2); 
		LinkageCalc();
		pos = m_loopList.GetHeadPosition();
		for(i = 0; i <= m_cplrLinkIndex; i++)
			pLink = (CLink*)m_loopList.GetNext(pos);
		dc.LineTo(pLink->m_pt1.x + m_rc*cos((m_ra[m_cplrLinkIndex] + m_ac)*PI/180.0),pLink->m_pt1.y - m_rc*sin((m_ra[m_cplrLinkIndex] + m_ac)*PI/180.0));
/*	}
*/
}


bool CInterfaceDoc::PreLinkageCalc()
{

//	CLink refLink;
	CString str;
	CLink *pLink;
	POSITION pos;
	pos = m_linkList.GetHeadPosition();
	for(int i = 0; i < m_EndIndex/2; i++)
	{
		pLink = (CLink*)m_linkList.GetNext(pos);
		//getting the reference link index
		if((pLink->m_pt1 == m_ptRef[0] && pLink->m_pt2 == m_ptRef[1] ) || (pLink->m_pt1 == m_ptRef[1] && pLink->m_pt2 == m_ptRef[0] ))
		{
			m_RefLink = *pLink;
			m_indexRefLink = i;
			////////////////???????????????/
			break;
		}
		if(*pLink == m_sldrAttachLink)
			m_sldrAttachIndex = i;
	}

	int j = m_indexRefLink;
	
	
	//new list of link is formed which has the refrence link at the top
	for(i = 0; i < m_EndIndex/2; i++)
	{
		if(j == m_EndIndex/2)//check
			j = 0;
		if(pLink = new CLink(*GetLink(GetLink(j))))//using oveloaded funcns
		{
			m_loopList.AddTail(pLink);
			j++;	
		}
//		str.Format("loop list %d,%d --- %d,%d",pLink->m_pt1.x,pLink->m_pt1.y,pLink->m_pt2.x,pLink->m_pt2.y);	
//		AfxMessageBox(str);
	}

	
	pos = m_loopList.GetHeadPosition();
//caluculating rm and ra
	double *rm = new double[m_EndIndex];
	for(i = 0; i < m_EndIndex/2; i++)
	{
		pLink = (CLink*)m_loopList.GetNext(pos);
		//getting the reference link index
/*		if((pLink->m_pt1 == m_ptRef[0] && pLink->m_pt2 == m_ptRef[1] ) || (pLink->m_pt1 == m_ptRef[1] && pLink->m_pt2 == m_ptRef[0] ))
		{
			refLink = *pLink;
			indexRefLink = i;
		}
*/		//creating information of link length and angle
		m_rm[i] = distance(pLink->m_pt1,pLink->m_pt2);
		m_ra[i] = (int)(360 - atan2((double)(pLink->m_pt2.y - pLink->m_pt1.y),(double)(pLink->m_pt2.x - pLink->m_pt1.x))*180.0/PI)%360;
		rm[i] = m_rm[i];
//		str.Format("Link Length : %9.2lf, Angle : %9.2lf",m_rm[i],m_ra[i]);
//		AfxMessageBox(str);
		if(*pLink == m_sldrAttachLink)
			m_sldrAttachIndex = i;
	
	}


	if(m_EndIndex/2 == 4)
	{
		qsort(rm,m_EndIndex/2,sizeof(double),compare);
		if(!(( rm[0] + rm[3] ) < (rm[1] + rm[2])))
		{
			AfxMessageBox("Not a Grashof Link. Set the Input Range");
			OnNewDocument();
			UpdateAllViews(NULL);
			return FALSE;
		}
	}	

	int k = 0;
	for(i = 0; i < m_EndIndex/2; i++)
	{
		pos = GetLink(i);
		pLink = GetLink(pos);
		//coupler
		if(m_cplrLink == *pLink)
			m_cplrLinkIndex = i;
		if( m_pInputLink ==  pLink)
			m_InputLinkIndex = i;
		else
		{
			for(j = 0; j < m_IndexRev; j++)
//angle of ref Link is fix
//for the angle of a link is calculated from its first point i.e. tail
//dependent variable are always 2, not less not more!!!
				if((!pLink->m_IsRef) && m_ptRev[j] == pLink->m_pt1 && k < 2)
				{
					m_indexA[k] = i;
					m_indexR[k] = NONE;
					k++;
				}
			j = 0;
			for(j= 1; j < m_IndexSldr; j += 2)
				if((pLink->m_pt1 == m_ptSldr[j] || pLink->m_pt2 == m_ptSldr[j] ) && k < 2)
				{
					m_indexR[k] = i;
					m_indexA[k] = NONE;
					k++;
				}
		}	
	}
	if(k <1)
	{
		AfxMessageBox("Error in Identifying the Linkage.\nDraw a New Linkage.");
		OnNewDocument();
		UpdateAllViews(NULL);
		return FALSE;
	}
	
	return TRUE;
}

void CInterfaceDoc::OnToolsCompile() 
{
	// TODO: Add your command handler code here

	if(m_nNewDoc > 0)
		m_loopList.RemoveAll();
	if(!m_IsInput)
		AfxMessageBox("You must set the Input Link");
	if(m_IndexRef < 1)
		AfxMessageBox("You must set the Refrence Link");


	if(!m_IsCompiled && m_IsInput && (m_IndexRef >= 1))
	{
		m_flag = (m_flag == ID_TOOLS_COMPILE? 0 : ID_TOOLS_COMPILE);	
		int i;
		SetDirection();
		CString str;
		if(!(m_rm   = new double[m_EndIndex/2]))
			exit(0);
		if(!(m_ra   = new double[m_EndIndex/2]))
			exit(0);
		if(!(m_drm  = new double[m_EndIndex/2]))
			exit(0);
		if(!(m_dra  = new double[m_EndIndex/2]))
			exit(0);
		if(!(m_ddrm = new double[m_EndIndex/2]))
			exit(0);
		if(!(m_ddra = new double[m_EndIndex/2]))
			exit(0);
		for( i = 0; i < m_EndIndex/2; i++)
		{
			m_ra[i]   = 0;
			m_rm[i]   = 0;
			m_dra[i]  = 0;
			m_drm[i]  = 0;
			m_ddra[i] = 0;
			m_ddrm[i] = 0;
		}
		//	POSITION pos;
		CLink *pLink,refLink;
		//ASSUMING FIRST TO BE INPUT LINK
		pLink = GetLink(GetLink(1));
		m_pInputLink = pLink;
		if(PreLinkageCalc())
			m_IsCompiled = TRUE;
	}	
}

void CInterfaceDoc::OnUpdateToolsCompile(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
/*	if(m_flag == ID_TOOLS_COMPILE)
	{
//		pCmdUI->SetCheck();
/*		if(m_IsCompiled)
			pCmdUI->Enable(FALSE);
		else
			pCmdUI->Enable(TRUE);
//		Invalidate();//draw the new screen
	}
	else
	{
		pCmdUI->SetCheck(0);
		if(m_IsCompiled || m_EndIndex < 6 )//if no. of link is 3 or if compiled than 
			pCmdUI->Enable(FALSE);
		else
			pCmdUI->Enable(TRUE);
	}
*/
}



void CInterfaceDoc::OnToolsPlots() 
{
	// TODO: Add your command handler code here
	m_flag = (m_flag == ID_TOOLS_PLOTS ? 0 : ID_TOOLS_PLOTS);
	CEntryDlg entrydlg;
/*	if(m_flag == ID_TOOLS_PLOTS)
	{	if(	entrydlg.DoModal() == IDOK)
			UpdateAllViews(NULL);
	}	 
	else
*/		UpdateAllViews(NULL);

}

void CInterfaceDoc::OnUpdateToolsPlots(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here

	if(m_flag == ID_TOOLS_PLOTS)
		pCmdUI->SetCheck();
	else
		pCmdUI->SetCheck(0);

	if(m_IsCompiled)//if compiled than 
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}	

void CInterfaceDoc::OnToolsInput() 
{
	// TODO: Add your command handler code here
	m_flag = (m_flag == ID_TOOLS_INPUT? 0 : ID_TOOLS_INPUT);
}

void CInterfaceDoc::OnUpdateToolsInput(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(m_flag == ID_TOOLS_INPUT)
	{
		pCmdUI->SetCheck();
		m_IsInput = TRUE;		
	}
	else
	{
		pCmdUI->SetCheck(0);

	}
}

