// interfaceDoc.h : interface of the CInterfaceDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTERFACEDOC_H__75989B0A_A6D4_11D4_B514_A9A27CD32F2A__INCLUDED_)
#define AFX_INTERFACEDOC_H__75989B0A_A6D4_11D4_B514_A9A27CD32F2A__INCLUDED_


#include "Link.h"	// Added by ClassView
#include "Quantity.h"
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class CInterfaceDoc : public CDocument
{
protected: // create from serialization only
	CInterfaceDoc();
	DECLARE_DYNCREATE(CInterfaceDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CInterfaceDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CInterfaceDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CInterfaceDoc)
	afx_msg void OnToolsLink();
	afx_msg void OnToolsSlider();
	afx_msg void OnToolsRevolute();
	afx_msg void OnToolsReferance();
	afx_msg void OnToolsDelete();
	afx_msg void OnToolsCoupler();
	afx_msg void OnUpdateToolsCoupler(CCmdUI* pCmdUI);
	afx_msg void OnToolsRun();
	afx_msg void OnUpdateToolsRun(CCmdUI* pCmdUI);
	afx_msg void OnToolsCompile();
	afx_msg void OnUpdateToolsCompile(CCmdUI* pCmdUI);
	afx_msg void OnToolsPlots();
	afx_msg void OnUpdateToolsPlots(CCmdUI* pCmdUI);
	afx_msg void OnToolsInput();
	afx_msg void OnUpdateToolsInput(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnUpdateToolsLink(CCmdUI *pCmdUI);
	afx_msg void OnUpdateToolsSlider(CCmdUI *pCmdUI);
	afx_msg void OnUpdateToolsRevolute(CCmdUI *pCmdUI);
	afx_msg void OnUpdateToolsReferance(CCmdUI *pCmdUI);
	afx_msg void OnUpdateToolsDelete(CCmdUI *pCmdUI);

	DECLARE_MESSAGE_MAP()
public:
	HWND m_hWnd;

	int m_cplrLinkIndex;//index of cplr link
	CPoint m_cplrPt;//PT TO WHICH it is attached
	CLink m_cplrLink;//coupler link
	COLORREF m_cplrColor;
	int m_IndexCoupler;//no of coupler pt. can be used in future
	void DrawCoupler(CDC &dc);//draw coupler
	CLink m_sldrPathLink,m_sldrAttachLink;
	bool m_linkCatchOn,m_sldrDlgShow;
	int m_sldrAttachIndex;
	//index will be -1 for not assigning 
	int m_indexA[2];//index of dependent variable which is angle
	int m_indexR[2];//index of dependent variable which is angle
	int m_timerValue;
	//calculation done independent of particular value of input angle
	//this is done to arrange all the information got through the graphical interface.
	bool PreLinkageCalc();
	//draw the linkage for the present value of input parameters
	void DrawLinkage(CDC &dc);
	CLink m_Link;
//	CLink m_InputLink;
	int m_InputLinkIndex;
	double m_a;//angular acceleration
	double m_w;//angualr velocity
	//calculations for dependent variables
	void LinkageCalc();
	//
	CLink *ArrangeNext(CLink *pLink);
	//
	CLink *GetNextLink(CLink *pLink);
	POSITION *GetLink(CPoint pt,int &j);
	POSITION GetLink(CPoint pt1, CPoint pt2);
	CLink  *m_pInputLink;
	CLink *GetLink(POSITION pos);
	//arrays for storing the info bout links there length and intial angles, angular/linear acceleration and velocities 
	double 	*m_ra;
	double  *m_rm;
	double 	*m_dra;
	double  *m_drm;
	double 	*m_ddra;
	double  *m_ddrm;
	//set the dirn of links in clockwise order 
	void SetDirection();
	POSITION NearestLink(CPoint& point,CDC& dc);
	CPoint m_End2;
	CPoint m_End1;
	CLink m_LinkCurr;
	//coupler curve param
	double m_ac;//angle of coupler curve
	double m_rc;//distance of coupler curve

	bool m_fSet;
	POSITION GetLink(int i);
	void AddLink();
	CPoint *m_ptRev,*m_ptRef,*m_ptSldr;
	int m_EndIndex;
	int m_TotalLink;
	CString m_sCoord;
	unsigned int m_flag;//Current Tool Flag
	int m_IndexRev;
	int m_IndexRef;
	int m_IndexSldr;

	CPtrList m_linkList;
/*	struct CNode
	{
		CPoint pt1;
		CPoint pt2;
	} m_NodeCurr;
*/	void SetLinkTail();
	HCURSOR m_hCross,m_hSelect;
	HCURSOR m_hCursor;
private:

	bool m_IsInput;
	CPoint m_sldrPt;//pt at which sldr is attached it is changing when it revolutes
	int m_nNewDoc;//no. of documents opened 
	bool m_IsCompiled;
	
	CLink m_RefLink;
	int m_indexRefLink;
	CPtrList m_loopList;
};

/////////////////////////////////////////////////////////////////////////////



//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INTERFACEDOC_H__75989B0A_A6D4_11D4_B514_A9A27CD32F2A__INCLUDED_)
