// interfaceView.h : interface of the CInterfaceView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_INTERFACEVIEW_H__75989B0C_A6D4_11D4_B514_A9A27CD32F2A__INCLUDED_)
#define AFX_INTERFACEVIEW_H__75989B0C_A6D4_11D4_B514_A9A27CD32F2A__INCLUDED_

#include "Link.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CInterfaceView : public CView
{
protected: // create from serialization only
	CInterfaceView();
	DECLARE_DYNCREATE(CInterfaceView)

// Attributes
public:

	CInterfaceDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CInterfaceView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CInterfaceView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CInterfaceView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CRgn m_rgnLastPV;//plot velocity
	CRgn m_rgnLastPA;//plot acc.
	CRgn m_rgnLastStr;
	CRgn m_rgnLastTR;//
	CRgn m_rgnLastTP;//
	CRgn m_rgnLastP;//plot
	CRgn m_rgnLastCplr;//for coupler curve
	CRgn m_rgnLastC;//for coupler pt.

	bool m_fCplrDrawn;
	void velocityPlot(CDC &dc);
	CRgn m_rgnLastGS;
	bool m_timerOn;
	CPoint m_LastPt;//last pt for drawing a link
	int m_LastDC;
	void Draw(CDC &dc);
	
	void makeSliderJoint(CDC *pDC);////to creat slider Joint
	void makeRevJoint(CPoint pt,CDC *pDC);//to make revolute Joint
	double distance(CPoint pt1,CPoint pt2);//distance of pt2 from pt2 or vice versa
	void  makeRef(CPoint pt1,CPoint pt2,CDC *pDC);//make the Link referance for the Mechanism
	double angle(CPoint pt1,CPoint pt2,CPoint pt3);//get the angle created by these pt when join in the order they are written
	double slope(CPoint  pt1, CPoint pt2);//slope of the line joining the two pts.
	CPoint m_ptMM;//pt set by mouse move event
	int m_indexM;//index of point array set by Magnet
	bool m_flagA;//flag for showing Angle set by mouse move and when m_flagM true
	CPoint m_pointM;//point set by Magnet in the range of 10 of mouse pointer
	bool m_flagM;//Magnet has caught a point
	bool Magnet(CPoint);//catching the nearest end pt.
	CRgn m_rgnLastBL,m_rgnLastBR,m_rgnLastRA,m_rgnLastRM;//just for future
public:
	CPoint NearestPixel(CDC &dc,CPoint point,COLORREF color);
	void acclPlot(CDC &dc);
	
	static LPCTSTR m_lpszClassName;
};

#ifndef _DEBUG  // debug version in interfaceView.cpp
inline CInterfaceDoc* CInterfaceView::GetDocument()
   { return (CInterfaceDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INTERFACEVIEW_H__75989B0C_A6D4_11D4_B514_A9A27CD32F2A__INCLUDED_)
